// SIDEBAR
const wiz_sidebar = document.createElement('div');
wiz_sidebar.id = "wiz-sidebar"
wiz_sidebar.className = 'wiz-style wiz-ui';
wiz_sidebar.style.cssText = `z-index: 999999; display: flex; position: fixed; top: 0; right: 0; flex-direction: row; height: 100vh; width: auto;`;
wiz_sidebar.innerHTML = `
    <!-- WizChat -->
    <div id="wiz-chat" style="width: 400px; border-left: 3px solid #00E6D2; box-shadow: 0 35px 60px -15px rgba(0, 0, 0, 0.3); display: flex; flex-direction: column; justify-content: space-between; padding: 16px 24px; height: 100vh; background-color: #131719;">
        <div style="display: flex;  padding: 0;  margin-bottom: 8px;  margin-left: 8px;  justify-content: flex-end;  align-items: center;">
            <button wizdata-button="clear_wizchat" style="border-radius: 4px; background-color: #1A2426; border: 2px solid #125D59; color: #00E6D2; display: flex; justify-content: center; align-items: center; padding: 6px; transition-duration: 200ms;">
                <svg xmlns="http://www.w3.org/2000/svg" style="height: 20px; width: 20px;" viewBox="0 0 24 24"><path fill="currentColor" d="M9.878 4.25a2.251 2.251 0 0 1 4.244 0a.75.75 0 1 0 1.415-.5a3.751 3.751 0 0 0-7.073 0a.75.75 0 1 0 1.414.5M2.75 6a.75.75 0 0 1 .75-.75h17a.75.75 0 0 1 0 1.5h-17A.75.75 0 0 1 2.75 6m2.367 1.752a.75.75 0 0 1 .798.698l.46 6.9c.09 1.347.154 2.285.294 2.99c.137.685.327 1.047.6 1.303c.274.256.648.422 1.34.512c.714.093 1.654.095 3.004.095h.774c1.35 0 2.29-.002 3.004-.095c.692-.09 1.066-.256 1.34-.512c.273-.256.463-.618.6-1.303c.14-.705.204-1.643.294-2.99l.46-6.9a.75.75 0 1 1 1.497.1l-.464 6.952c-.085 1.282-.154 2.318-.316 3.132c-.169.845-.455 1.551-1.047 2.104s-1.315.793-2.17.904c-.822.108-1.86.108-3.145.108h-.88c-1.285 0-2.323 0-3.145-.108c-.855-.111-1.579-.35-2.17-.904c-.592-.553-.878-1.26-1.047-2.104c-.162-.814-.23-1.85-.316-3.132L4.418 8.55a.75.75 0 0 1 .699-.798"/></svg>
            </button>
        </div>
        
        <div id="wiz-chat-messages-scroll-container" style="max-height: calc(100vh - 120px); overflow-y: auto;  padding-left: 8px; padding-right: 8px;  padding-bottom: 16px;  margin-bottom: 0;  flex: 1 1 0%;">
            <div id="wiz-chat-messages-container" style="display: flex;  margin-top: 8px;  flex-direction: column;  font-size: 14px; line-height: 20px;"></div>
        </div>
        <div style="display: flex;  flex-direction: column;  justify-content: center;  align-items: center;  width: 100%;">
            <div style="display: flex;  position: relative;  align-items: center;  width: 100%;">
                <input type="text" style="width: 100%; font-size: 14px; margin-bottom: 0; height: 48px; background-color: white; border: 1px solid #565869; border-radius: 4px; color: #1A2426; padding: 12px 16px; padding-right: 40px; outline: none; transition: border-color 0.2s ease;" placeholder="Ask a question..." id="wiz-chatinput">
                <button wizdata-button="send_query" style="position: absolute; right: 8px; top: 0; height: 48px; display: flex; align-items: center; color: #acacbe; transition: color 0.2s ease;">
                    <svg xmlns="http://www.w3.org/2000/svg" fill="none" viewBox="0 0 24 24" stroke-width="1.5" stroke="currentColor" style="width: 20px; height: 20px;">
                        <path stroke-linecap="round" stroke-linejoin="round" d="M6 12L3.269 3.126A59.768 59.768 0 0121.485 12 59.77 59.77 0 013.27 20.876L5.999 12zm0 0h7.5" />
                    </svg>
                </button>
            </div>
            <p style="font-size: 12px; color: rgba(255,255,255,0.5); text-align: center; margin-top: 12px; margin-bottom: 8px; line-height: 1;">WizChat can make mistakes. Check important info.</p>
        </div>
    </div>

    <!-- Privous Answers History -->
    <div id="wiz-history" style="width: 400px; border-left: 3px solid #00E6D2; box-shadow: 0 35px 60px -15px rgba(0, 0, 0, 0.3); display: flex; flex-direction: column; justify-content: space-start; padding: 16px 24px; height: 100vh; background-color: #131719;">
        <div style="display: flex;  padding: 0;  margin-bottom: 8px;  margin-left: 8px;  justify-content: flex-end;  align-items: center;">
            <button wizdata-button="clear_wizhistory" style="border-radius: 4px; background-color: #1A2426; border: 2px solid #125D59; color: #00E6D2; display: flex; justify-content: center; align-items: center; padding: 6px; transition-duration: 200ms;">
                <svg xmlns="http://www.w3.org/2000/svg" style="height: 20px; width: 20px;" viewBox="0 0 24 24"><path fill="currentColor" d="M9.878 4.25a2.251 2.251 0 0 1 4.244 0a.75.75 0 1 0 1.415-.5a3.751 3.751 0 0 0-7.073 0a.75.75 0 1 0 1.414.5M2.75 6a.75.75 0 0 1 .75-.75h17a.75.75 0 0 1 0 1.5h-17A.75.75 0 0 1 2.75 6m2.367 1.752a.75.75 0 0 1 .798.698l.46 6.9c.09 1.347.154 2.285.294 2.99c.137.685.327 1.047.6 1.303c.274.256.648.422 1.34.512c.714.093 1.654.095 3.004.095h.774c1.35 0 2.29-.002 3.004-.095c.692-.09 1.066-.256 1.34-.512c.273-.256.463-.618.6-1.303c.14-.705.204-1.643.294-2.99l.46-6.9a.75.75 0 1 1 1.497.1l-.464 6.952c-.085 1.282-.154 2.318-.316 3.132c-.169.845-.455 1.551-1.047 2.104s-1.315.793-2.17.904c-.822.108-1.86.108-3.145.108h-.88c-1.285 0-2.323 0-3.145-.108c-.855-.111-1.579-.35-2.17-.904c-.592-.553-.878-1.26-1.047-2.104c-.162-.814-.23-1.85-.316-3.132L4.418 8.55a.75.75 0 0 1 .699-.798"/></svg>
            </button>
        </div>
        <div id="wiz-history-scroll-container" style="max-height: 100vh; overflow-y: auto;  padding-left: 8px; padding-right: 8px;  padding-bottom: 8px;  margin-bottom: 0;  flex: 1 1 0%;">
            <div id="wiz-history-container" style="display: flex;  margin-top: 8px;  flex-direction: column;  font-size: 14px; line-height: 20px;"></div>
        </div>
    </div>

    <div style="width: 80px; height: background-color: #131719; 100%; border-left: 3px solid #00E6D2; padding-top: 32px; display: flex; flex-direction: column; align-items: center; justify-content: space-between;">

        <!-- Top -->
        <div style="border-radius: 4px; background-color: #125D59; border: 2px solid #22C3B9; display: flex; justify-content: center; align-items: center; height: 48px; width: 48px; margin-bottom: 0;">
            <div class="wiz-action-button">
                <img style="width: 24px; height: auto;" src="https://canvaswizard.co/img/canvas-wizard-logo-white-hat-with-angry-eyes.png" alt="">
                <div class="wiz-tooltip" style="position: absolute; pointer-events: none; z-index: 99999; height: 48px; display: flex; justify-content: center; align-items: center; right: 100%; margin-right: 18px; transform: translateY(-100%); opacity: 0; transition: opacity 200ms; white-space: nowrap;">
                    <div style="color: white; height: auto; font-weight: 600; background-color: #131719; border-radius: 9999px; padding: 4px 12px; font-size: 12px; box-shadow: 0 10px 15px -3px rgba(0, 0, 0, 0.1); white-space: nowrap;">CanvasWizard.co</div>
                </div>
            </div>
        </div>
        
        <!-- Mid -->
        <div>
            <div style="display: flex; position: relative; z-index: 99999; margin-top: 0;">
                <div class="wiz-action-button">
                    <button wizdata-button="chat" style="border-radius: 4px; background-color: #1A2426; border: 2px solid #125D59; color: #00E6D2; display: flex; justify-content: center; align-items: center; height: 48px; width: 48px; padding: 8px; transition-duration: 200ms;">
                        <svg xmlns="http://www.w3.org/2000/svg" style="width: auto; height: 100%;"  viewBox="0 0 24 24"><path fill="none" stroke="currentColor" stroke-width="1.5" d="M3 20.29V5a2 2 0 0 1 2-2h14a2 2 0 0 1 2 2v10a2 2 0 0 1-2 2H7.961a2 2 0 0 0-1.561.75l-2.331 2.914A.6.6 0 0 1 3 20.29Z"/></svg>
                    </button>
                    <div class="wiz-tooltip" style="position: absolute; pointer-events: none; z-index: 99999; height: 48px; display: flex; justify-content: center; align-items: center; right: 100%; margin-right: 24px; transform: translateY(-100%); opacity: 0; transition: opacity 200ms; white-space: nowrap;">
                        <div style="color: white; height: auto; font-weight: 600; background-color: #131719; border-radius: 9999px; padding: 4px 12px; font-size: 12px; box-shadow: 0 10px 15px -3px rgba(0, 0, 0, 0.1); white-space: nowrap;">WizChat</div>
                    </div>
                </div>
            </div>
            
            <div style="display: flex; position: relative; z-index: 99999; margin-top: 12px;">
                <div class="wiz-action-button">
                    <button wizdata-button="screenshot" style="border-radius: 4px; background-color: #1A2426; border: 2px solid #125D59; color: #00E6D2; display: flex; justify-content: center; align-items: center; height: 48px; width: 48px; padding: 8px; transition-duration: 200ms;">
                        <svg xmlns="http://www.w3.org/2000/svg" style="width: auto; height: 100%;" viewBox="0 0 24 24"><g fill="none" stroke="currentColor" stroke-linecap="round" stroke-linejoin="round" stroke-width="1.5"><path d="M10 21.4v-7.006a.6.6 0 0 1 .6-.6h1.173a.6.6 0 0 0 .504-.275l1.446-2.244a.6.6 0 0 1 .504-.275h3.546a.6.6 0 0 1 .504.275l1.446 2.244a.6.6 0 0 0 .504.275H21.4a.6.6 0 0 1 .6.6V21.4a.6.6 0 0 1-.6.6H10.6a.6.6 0 0 1-.6-.6"/><path d="M16 19a2 2 0 1 0 0-4a2 2 0 0 0 0 4M3 18v3h2.5M3 9.5v5M3 6V3h3m3.5 0h5M18 3h3v2.5m0 4.5V8.5"/></g></svg>
                    </button>
                    <div class="wiz-tooltip" style="position: absolute; pointer-events: none; z-index: 50; height: 48px; display: flex; justify-content: center; align-items: center; right: 100%; margin-right: 24px; transform: translateY(-100%); opacity: 0; transition: opacity 200ms; white-space: nowrap;">
                        <div style="color: white; height: auto; font-weight: 600; background-color: #131719; border-radius: 9999px; padding: 4px 12px; font-size: 12px; box-shadow: 0 10px 15px -3px rgba(0, 0, 0, 0.1); white-space: nowrap;">Screenshot Question</div>
                    </div>
                </div>
            </div>
    
            <div style="display: flex; position: relative; z-index: 99999; margin-top: 12px;">
                <div class="wiz-action-button">
                    <button wizdata-button="notes" style="border-radius: 4px; background-color: #1A2426; border: 2px solid #125D59; color: #00E6D2; display: flex; justify-content: center; align-items: center; height: 48px; width: 48px; padding: 6px; transition-duration: 200ms;">
                        <svg xmlns="http://www.w3.org/2000/svg" style="width: auto; height: 100%;" viewBox="0 0 24 24"><path fill="currentColor" d="M5.616 19H14v-4.192q0-.344.232-.576t.576-.232H19V5.616q0-.27-.173-.443T18.385 5H5.615q-.269 0-.442.173T5 5.616v12.769q0 .269.173.442t.443.173m0 1q-.667 0-1.141-.475T4 18.386V5.615q0-.666.475-1.14T5.615 4h12.77q.666 0 1.14.475T20 5.615v8.002q0 .332-.13.632t-.349.518l-4.754 4.754q-.217.218-.517.348t-.633.131zm5.884-6.538H8.385q-.213 0-.357-.144q-.143-.144-.143-.357t.143-.356t.357-.143H11.5q.213 0 .356.144t.144.356t-.144.356t-.356.144M15.616 9.5H8.385q-.213 0-.357-.144t-.143-.357t.143-.356t.357-.143h7.23q.213 0 .357.144t.144.357t-.144.356t-.356.143M5 19V5z"/></svg>
                    </button>
                    <div class="wiz-tooltip" style="position: absolute; pointer-events: none; z-index: 50; height: 48px; display: flex; justify-content: center; align-items: center; right: 100%; margin-right: 24px; transform: translateY(-100%); opacity: 0; transition: opacity 200ms; white-space: nowrap;">
                        <div style="color: white; height: auto; font-weight: 600; background-color: #131719; border-radius: 9999px; padding: 4px 12px; font-size: 12px; box-shadow: 0 10px 15px -3px rgba(0, 0, 0, 0.1); white-space: nowrap;">Quick Notes</div>
                    </div>
                </div>
            </div>
    
            <div style="display: flex; position: relative; z-index: 99999; margin-top: 12px;">
                <div class="wiz-action-button">
                    <button wizdata-button="history" style="border-radius: 4px; background-color: #1A2426; border: 2px solid #125D59; color: #00E6D2; display: flex; justify-content: center; align-items: center; height: 48px; width: 48px; padding: 8px; transition-duration: 200ms;">
                        <svg xmlns="http://www.w3.org/2000/svg" style="width: auto; height: 100%;" viewBox="0 0 24 24"><path fill="currentColor" d="M6.865 6.882A7.25 7.25 0 1 1 4.75 12a.75.75 0 0 0-1.5 0a8.75 8.75 0 1 0 2.552-6.176a1 1 0 0 0-.07.08L4.475 4.646a.5.5 0 0 0-.852.309L3.27 8.844a.5.5 0 0 0 .543.543l3.89-.354a.5.5 0 0 0 .307-.851L6.782 6.954a1 1 0 0 0 .083-.072"/><path fill="currentColor" d="M12.75 7a.75.75 0 0 0-1.5 0v5a.75.75 0 0 0 .352.636l3 1.875a.75.75 0 1 0 .796-1.272l-2.648-1.655z"/></svg>
                    </button>
                    <div class="wiz-tooltip" style="position: absolute; pointer-events: none; z-index: 50; height: 48px; display: flex; justify-content: center; align-items: center; right: 100%; margin-right: 24px; transform: translateY(-100%); opacity: 0; transition: opacity 200ms; white-space: nowrap;">
                        <div style="color: white; height: auto; font-weight: 600; background-color: #131719; border-radius: 9999px; padding: 4px 12px; font-size: 12px; box-shadow: 0 10px 15px -3px rgba(0, 0, 0, 0.1); white-space: nowrap;">Previous Answers</div>
                    </div>
                </div>
            </div>

            <div style="display: flex; position: relative; z-index: 99999; margin-top: 12px;">
                <div class="wiz-action-button">
                    <button wizdata-button="hide_sidebar" style="border-radius: 4px; background-color: #1A2426; border: 2px solid #125D59; color: #00E6D2; display: flex; justify-content: center; align-items: center; height: 48px; width: 48px; padding: 8px; transition-duration: 200ms;">
                        <svg xmlns="http://www.w3.org/2000/svg" style="width: auto; height: 24px;" viewBox="0 0 24 24"><path fill="currentColor" d="M12.08 4.08L20 12l-7.92 7.92l-1.41-1.42l5.5-5.5H2v-2h14.17l-5.5-5.5zM20 12v10h2V2h-2z"/></svg>
                    </button>
                    <div class="wiz-tooltip" style="position: absolute; pointer-events: none; z-index: 50; height: 48px; display: flex; justify-content: center; align-items: center; right: 100%; margin-right: 24px; transform: translateY(-100%); opacity: 0; transition: opacity 200ms; white-space: nowrap;">
                        <div style="color: white; height: auto; font-weight: 600; background-color: #131719; border-radius: 9999px; padding: 4px 12px; font-size: 12px; box-shadow: 0 10px 15px -3px rgba(0, 0, 0, 0.1); white-space: nowrap;">Hide Sidebar</div>
                    </div>
                </div>
            </div>
        </div>

        <!-- Bottom -->
        <div style="margin-bottom: 24px;">
            <div style="display: flex; position: relative; z-index: 99999;">
                <div class="wiz-action-button">
                    <a href="https://canvaswizard.co/help" target="_blank" style="border-radius: 4px; width: 48px; background-color: #1A2426; color: #00E6D2; display: flex; flex-direction: column; justify-content: center; align-items: center; border: 2px solid #125D59; padding: 6px 10px 6px 10px; transition-duration: 200ms;">
                        <svg xmlns="http://www.w3.org/2000/svg"  style="width: 22px !important; height: 22px !important; margin-bottom: 4px;" viewBox="0 0 24 24"><path fill="currentColor" d="M11.07 12.85c.77-1.39 2.25-2.21 3.11-3.44c.91-1.29.4-3.7-2.18-3.7c-1.69 0-2.52 1.28-2.87 2.34L6.54 6.96C7.25 4.83 9.18 3 11.99 3c2.35 0 3.96 1.07 4.78 2.41c.7 1.15 1.11 3.3.03 4.9c-1.2 1.77-2.35 2.31-2.97 3.45c-.25.46-.35.76-.35 2.24h-2.89c-.01-.78-.13-2.05.48-3.15M14 20c0 1.1-.9 2-2 2s-2-.9-2-2s.9-2 2-2s2 .9 2 2"/></svg>
                        <!--  <p style="font-size: 12px; font-weight: 600; line-height: 1; margin: 0px;">001</p> -->
                    </a>
                    <div class="wiz-tooltip" style="position: absolute; pointer-events: none; z-index: 50; height: 48px; display: flex; justify-content: center; align-items: center; right: 100%; margin-right: 24px; transform: translateY(-100%); opacity: 0; transition: opacity 200ms; white-space: nowrap;">
                        <div style="color: white; height: auto; font-weight: 600; background-color: #131719; border-radius: 9999px; padding: 4px 12px; font-size: 12px; box-shadow: 0 10px 15px -3px rgba(0, 0, 0, 0.1); white-space: nowrap;">Help</div>
                    </div>
                </div>
            </div>
        </div>
    </div>
`
const wiz_expandbar = document.createElement('div');
wiz_expandbar.id = "wiz-expandbar";
wiz_expandbar.className = 'wiz-style wiz-ui';
wiz_expandbar.style.cssText = `
    z-index: 99999;
    position: fixed;
    top: 0;
    right: 0;
    height: 100vh;
    width: 36px;
    background-color: transparent;
    opacity: 0;
    transition: opacity 0.3s ease-in-out;
`;

wiz_expandbar.addEventListener('mouseenter', () => {
    wiz_expandbar.style.opacity = "1";
    wiz_expandbar.style.cursor = "pointer";
});

wiz_expandbar.addEventListener('mouseleave', () => {
    wiz_expandbar.style.opacity = "0";
});

wiz_expandbar.innerHTML = `
    <div style="display: flex; flex-direction: column; justify-content: center; align-items: center; height: 100vh; width: 36px;">
        <button wizdata-button="show_sidebar" style="
            display: flex;
            padding: 6px 8px;
            flex-direction: row;
            justify-content: center;
            align-items: center;
            border-top-left-radius: 8px;
            border-top-right-radius: 8px;
            border: 2px solid #00E6D2;
            font-size: 12px;
            line-height: 16px;
            font-weight: 600;
            color: #ffffff;
            white-space: nowrap;
            transition-duration: 200ms;" 
            class="hover:bg-wiz-mint bg-wiz-darkgreen -rotate-90">
            <span>Google Sidebar</span>
            <svg xmlns="http://www.w3.org/2000/svg" style="width: 16px; height: 16px; margin-left: 8px" viewBox="0 0 24 24">
                <path fill="currentColor" d="M12 13.825L8.1 17.7q-.275.275-.687.288T6.7 17.7q-.275-.275-.275-.7t.275-.7l4.6-4.6q.15-.15.325-.213t.375-.062t.375.062t.325.213l4.6 4.6q.275.275.288.688t-.288.712q-.275.275-.7.275t-.7-.275zm0-6L8.1 11.7q-.275.275-.687.288T6.7 11.7q-.275-.275-.275-.7t.275-.7l4.6-4.6q.15-.15.325-.212T12 5.425t.375.063t.325.212l4.6 4.6q.275.275.288.688t-.288.712q-.275.275-.7.275t-.7-.275z"/>
            </svg>
        </button>
    </div>
`;

document.body.appendChild(wiz_expandbar);


document.body.appendChild(wiz_sidebar);
document.body.appendChild(wiz_expandbar);

// SIDEBAR HIDE/SHOW
document.querySelector('[wizdata-button="hide_sidebar"]').addEventListener('click', () => {
    chrome.storage.local.get(['wiz_settings']).then(result => {
        chrome.storage.local.set({ 
            wiz_settings: {
                ...result.wiz_settings,
                sidebar_visible: false
            }
        });
    });
});

document.querySelector('[wizdata-button="show_sidebar"]').addEventListener('click', () => {
    chrome.storage.local.get(['wiz_settings']).then(result => {
        chrome.storage.local.set({ 
            wiz_settings: {
                ...result.wiz_settings,
                sidebar_visible: true
            }
        });
    });
});


// Detect Canvas Page
// Inject the HTML if document.querySelector('.ic-app-header__main-navigation') is true + class="ic-Layout-wrapper" is found
if (document.querySelector('.ic-app-header__main-navigation') && document.querySelector('.ic-Layout-wrapper')) {};
